VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox Text2 
      BeginProperty Font 
         Name            =   "UPC-A"
         Size            =   27.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1005
      Left            =   1080
      TabIndex        =   2
      Top             =   840
      Width           =   2775
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   1080
      TabIndex        =   1
      Top             =   240
      Width           =   2775
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Encode"
      Height          =   375
      Left            =   1560
      TabIndex        =   0
      Top             =   2280
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Barcode"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   840
      Width           =   855
   End
   Begin VB.Label Label1 
      Caption         =   "Plain Text"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   240
      Width           =   735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Function EncodeUPCA(ByVal szBarcode As String) As String

Dim szEncoded As String
Dim szTemp As String
Dim lnCounter As Long
Dim dlChecksum As Double
Dim szCheckChar As String

szEncoded = ""

'UPC-A barcodes are 11 digits long + check character
szTemp = Left(szBarcode, 11)
If Len(szTemp) <> 11 Then
    EncodeUPCA = szEncoded
    Exit Function
End If

'Add the odd characters
For lnCounter = 1 To 11 Step 2
    dlChecksum = dlChecksum + Val(Mid(szTemp, lnCounter, 1)) * 3
Next

'Add the even characters
For lnCounter = 2 To 10 Step 2
    dlChecksum = dlChecksum + Val(Mid(szTemp, lnCounter, 1))
Next

'Calculate the check character
szCheckChar = Right(CStr(10 - dlChecksum Mod 10), 1)

'Add the check charater to the barcode
szTemp = szTemp + szCheckChar

'Encode the barcode
szEncoded = Chr(80 + Val(Mid(szTemp, 1, 1)))
For lnCounter = 2 To 6
    szEncoded = szEncoded + Chr(48 + Val(Mid(szTemp, lnCounter, 1)))
Next
szEncoded = szEncoded + Chr(112)
For lnCounter = 7 To 11
    szEncoded = szEncoded + Chr(64 + Val(Mid(szTemp, lnCounter, 1)))
Next
szEncoded = szEncoded + Chr(96 + Val(Mid(szTemp, 12, 1)))

EncodeUPCA = szEncoded

End Function


Private Sub Command1_Click()

If Len(Text1) <> 11 Then
    MsgBox "UPC-A barcodes are 11 characters long."
    Exit Sub
End If

Text2 = EncodeUPCA(Text1)

End Sub


